var joi = require('joi');

module.exports.default = function InputJS(data, schema) {
  var valid = joi.validate(data, schema, {stripUnknown: true});

  this.schema = function() {
    return schema;
  };
  this.validateError = function () {
    if (!valid.error) return null;
    return new Error(valid.error.details[0].message);
  };

  if (valid.value) {
    var keys = Object.keys(valid.value);
    var len = keys.length;
    var i = 0;

    while (i < len) {
      this[keys[i]] = data[keys[i]];
      i++;
    }
  }
}
